// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _LIBGDAMM_DATAACCESSWRAPPER_H
#define _LIBGDAMM_DATAACCESSWRAPPER_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

// -*- C++ -*- //

/* dataaccesswrapper.h
 *
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <libgdamm/datamodel.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaDataAccessWrapper GdaDataAccessWrapper;
typedef struct _GdaDataAccessWrapperClass GdaDataAccessWrapperClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Gnome
{

namespace Gda
{ class DataAccessWrapper_Class; } // namespace Gda

} // namespace Gnome
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Gnome
{

namespace Gda
{

/** Offers random access on top of a cursor-only access data model.
 *
 * The Gda::DataAccessWrapper object simply wraps around another Gda::DataModel data model 
 * object and allows data to be accessed in a random way while remaining memory efficient as much as possible.
 *
 * @ingroup DataModels
 */

class DataAccessWrapper
 : public Glib::Object,
   public DataModel
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef DataAccessWrapper CppObjectType;
  typedef DataAccessWrapper_Class CppClassType;
  typedef GdaDataAccessWrapper BaseObjectType;
  typedef GdaDataAccessWrapperClass BaseClassType;

  // noncopyable
  DataAccessWrapper(const DataAccessWrapper&) = delete;
  DataAccessWrapper& operator=(const DataAccessWrapper&) = delete;

private:  friend class DataAccessWrapper_Class;
  static CppClassType dataaccesswrapper_class_;

protected:
  explicit DataAccessWrapper(const Glib::ConstructParams& construct_params);
  explicit DataAccessWrapper(GdaDataAccessWrapper* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  DataAccessWrapper(DataAccessWrapper&& src) noexcept;
  DataAccessWrapper& operator=(DataAccessWrapper&& src) noexcept;

  virtual ~DataAccessWrapper() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaDataAccessWrapper*       gobj()       { return reinterpret_cast<GdaDataAccessWrapper*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaDataAccessWrapper* gobj() const { return reinterpret_cast<GdaDataAccessWrapper*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaDataAccessWrapper* gobj_copy();

private:

  
protected:
    explicit DataAccessWrapper(const Glib::RefPtr<DataModel>& model);


public:
  
  static Glib::RefPtr<DataAccessWrapper> create(const Glib::RefPtr<DataModel>& model);

  
  /** Data model being wrapped.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<DataModel> > property_model() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::DataAccessWrapper
   */
  Glib::RefPtr<Gnome::Gda::DataAccessWrapper> wrap(GdaDataAccessWrapper* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_DATAACCESSWRAPPER_H */

